clear all;

N=200;

%cov_ksi = 4*eye(n,n);
cov_ksi=[4 2 3 ; 2 9 6 ; 3 6 16];
%M_ksi=zeros(n,1);
M_ksi=[-10; 0; 10];

n=size(cov_ksi,1);

U=randn(n,N);
cov_u = eye(n,n);

A=zeros(n,n);

%if (size(cov_ksi) ~= n) | (size(M_ksi) ~= n)
if (size(M_ksi) ~= n)
%    error('  ov_ksi      M_ksi   n');
    error('    M_ksi   n');
end

for i=1:n,
    if det(cov_ksi(1:i,1:i)) <= 0
        error(' ov_ksi   ');
    end
end
        
for i=1:n, 
    for j=1:i,
       
        sum=0;
        for k=1:(j-1),
            sum=sum+A(i,k)*A(j,k)*cov_u(k,k);
        end
        if i==j
            A(i,j)=sqrt((cov_ksi(i,j)-sum)/cov_u(j,j)); 
        else
            A(i,j)=(cov_ksi(i,j)-sum)/(A(j,j)*cov_u(j,j));
        end
    end
end

for i=1:N,
   ksi(:,i)=A*U(:,i) + M_ksi;
end

ksi_t=ksi';
%    out.txt
save out.txt ksi_t -ASCII
disp('  A');
A
disp('   U');
U;
disp('  ksi');
ksi;
disp('.  cov_ksi');
cov_ksi;
disp('. .  cov_ksi');
test_cov_ksi=cov(ksi_t)
disp(' cov_ksi (  )');
A*cov_u*A'




figure(1);
hist(U',20);
xlabel('');
ylabel(sprintf('  %g',N));

figure(2);
hist(ksi',40);
xlabel('');
ylabel(sprintf('  %g',N));